function [y,T,lam,res,iter,A,p,jac]=chonloopext(p,y1,T1,lam1,ds)
% chonloopext: Newton loop for constrained Hopf in arclength
if p.fsol.fsol==1
    [y,T,lam,res,iter,A,p,jac]=fsolext(p,y1,T1,lam1,ds); 
    return; 
end
iter=0; y=y1; T=T1; lam=lam1; p=setlam(p,lam); % set lam to predictor
nu=p.nu; na=nu+p.nc.nq; tl=p.hopf.tl; 
par=getaux(p); a=par(p.hopf.ilam); 
alpha=1; almin=alpha/4; % minimal damping 
[f,jac,f_T,f_lam,f_a]=tomassempbc(p,y,T,lam); 
[pc,pc_y]=hopc(p,y,T,lam); arcl=hoarcl(p,y,T,lam,ds,a);
qf=p.hopf.qfh(p,y); 
F=[f; pc; arcl; qf]; 
if p.sw.verb>1; fprintf('initial (||f||, pc, arcl,qf,a)=(%g,%g,%g,%g,%g)\n',...
        norm(f,p.sw.norm),pc,arcl,norm(qf),norm(a)); end
res0=norm(F,p.sw.norm); res=res0;  %pause  % the residual 
ytom=reshape(y1(1:na*tl),na,tl); % convert to tom-input 
qhder=getqhder(p,y); 
A=gethoA(p,jac,f_T,f_lam,pc_y,p.hopf.tau,f_a,qhder); 
%figure(6); clf; spy(A); pause %size(A), size(F),pause
tol=p.nc.tol; 
if(res<tol); return; end; % initial res. small, do nothing! 
% now start the actual loop
stepok=1; % stepok=1 indicates that step of size alpha decreased residual  
while(abs(res0)>tol && iter<p.nc.imax && stepok) 
  [upd,p]=p.fuha.blss(A,F,p); %upd(1:5)',upd(end-1:end)', pause
  stepok=0; yv=reshape(y(1:na,:),na*tl,1); % make y-vector
  while(stepok==0 && alpha>=almin)   
  y1=yv-alpha*upd(1:na*tl); 
  T1=T-alpha*upd(na*tl+1); 
  lam1=lam-alpha*upd(na*tl+2); 
  a1=a-1*alpha*upd(na*tl+3:end); %a,a1, pause
  %par(3)=a1; %% need to change later
  p.u(p.nu+p.hopf.ilam)=a1; 
  ytom=reshape(y1(1:na*tl),na,tl); % convert to tom-input 
  f=tomassempbc(p,ytom,T1,lam1);  % setlam(p,lam1) done in tomassempbc! 
  [pc,pc_y]=hopc(p,ytom,T1,lam1); arcl=hoarcl(p,ytom,T1,lam1,ds,a1); 
  qf=p.hopf.qfh(p,y); % [qfj,qfa]=p.hopf.qfhder(p,y); 
  F=[f; pc; arcl; qf];
  if p.sw.verb>1; 
      fprintf('al=%g, (||f||, pc, arcl, qf,a)=(%g,%g,%g,%g,%g)\n',alpha,norm(f,p.sw.norm),pc,arcl,norm(qf),norm(a1));end
  res=norm(F,p.sw.norm); if p.sw.verb>1; disp(['res=' mat2str(res,6)]); end % check new tom-resi 
  %pause 
  if(res<res0); % good step  
    if(res<res0/2 && alpha<1) alpha=alpha*2; end % very good step  
    stepok=1; y=ytom; T=T1; lam=lam1; a=a1; res0=res;
    [f,jac,f_T,f_lam, f_a]=tomassempbc(p,y,T,lam); 
    [pc,pc_y]=hopc(p,y,T,lam); qhder=getqhder(p,y); 
    A=gethoA(p,jac,f_T,f_lam,pc_y,p.hopf.tau,f_a,qhder); 
  else alpha=alpha/2; % bad step, try smaller alpha
  end % res<res0
  end % while stepok==0
  iter=iter+1;
end % while res>p.nc.tol && stepok 
%fprintf('al=%g, (||f||, pc, arcl)=(%g,%g,%g)\n',alpha,norm(f,p.sw.norm),pc,arcl);
% ----------------------------------------------------------postprocessing
if(p.sw.verb>1); if(alpha<1) fprintf('\n chonloopext: damp alpha=%g, res=%g, ds=%g\n',...
            alpha,res,ds); end; end; % inform user if damping was used 
res=res0; y=ytom; 
