function [p,bif]=hobifdetec(p,y,tau,jac,muv1,muv2,ind)
% hobifdetec: Hopf version of bifdetec, with few bisections, para=4
% required
if ~p.hopf.indini || ind==p.hopf.oldind; bif=0; return; end
mucand=0.9; try; mucand=muv1(end-1); end % candidate
if ind>p.hopf.oldind; try; mucand=muv2(1); end; end % if new unstable multiplier(s)
fprintf('possible Bif from Hopf, old-ind=%i, ind=%i, abs(mu)=%g, mu=%g+%gi\n', ...
         p.hopf.oldind, ind, abs(mucand), real(mucand), imag(mucand)); 
bif=1; 
q=p; % to later restore
tl=p.hopf.tl; nqh=p.hopf.nqh; na=p.nu+p.nc.nq; ds=p.sol.ds; % just some shorthands 
try; hobisec=p.hopf.bisec; catch  hobisec=3; end 
for i=1:hobisec
    ds=ds/2;  % half stepsize
    fprintf('ds=%g,  ',ds); 
    y1=p.hopf.y+ds*v2tom(p,p.hopf.tau);    % predictor
    T1=p.hopf.T+ds*p.hopf.tau(na*tl+1); 
    lam0=p.hopf.lam; lam1=lam0+ds*p.hopf.tau(na*tl+2); 
    if nqh>0; s0=p.u(p.nu+p.hopf.ilam);   % Hopf with constraints, assume aux-vars 
      s1=s0+ds*p.hopf.tau(na*tl+3:end)'; p.u(p.nu+p.hopf.ilam)=s1;% aux-vars predictor
      [y,T,lam,res,iter,A,p]=chonloopext(p,y1,T1,lam1,ds); % corrector 
    else [y,T,lam,res,iter,A,p]=honloopext(p,y1,T1,lam1,ds); 
    end 
    p.hopf.T=T; p.hopf.lam=lam; p.hopf.y=y; p=setlam(p,lam); par=p.u(p.nu+1:end); 
    jac=A(1:p.nu*tl, 1:p.nu*tl); [muv1,muv2,ind1]=floq(p,jac); % new floq
   % muv1(end-2:end)', muv2,     
    muc=getmuc(muv1,muv2); fprintf('ga_crit=%g\n',muc); 
    %fprintf('%i, (%g,%i) (%g,%i), %g\n',p.hopf.oldind,lam0,ind,lam1,ind1, muc); pause 
    if ind1==p.hopf.oldind % behind BP, do nothing, i.e., just reduce ds again 
       %fprintf('before BP\n'); 
    else %fprintf('behind BP\n'); 
       p.hopf.T=T; p.hopf.lam=lam; p.hopf.y=y; ds=-ds; 
       p.hopf.oldind=ind1; p=setlam(p,lam); par=p.u(p.nu+1:end); 
       if nqh>0; [tau,p]=p.fuha.blss(A,[zeros(na*tl+1,1); 1; zeros(p.hopf.nqh,1)],p);
       else [tau,p]=p.fuha.blss(A,[zeros(p.nu*tl+1,1); 1],p); 
       end
       hn=honorm(p,tau); tau=tau/hn; p.hopf.tau=tau';  % new tangent
    end 
end
p.hopf.T=T; p.hopf.lam=lam; p.hopf.y=y;  % update and save 
p.sol.res=res; p=setlam(p,lam); par=p.u(p.nu+1:end); 
p.hopf.ind=ind; p.hopf.indini=1; p.hopf.oldind=ind;
p.hopf.muv1=muv1; p.hopf.muv2=muv2; p.sol.ptype=1; 
if isfield(p.hopf,'auxp'); p.hopf.auxp(p); end % auxiliary plot 
brout=[bradat(p); p.fuha.outfu(p,p.u)];     % userfu to append to bif-branches  
brplot=brout(length(bradat(p))+p.plot.bpcmp);    % y-axis value in bif-figure
%p.hopf.tau=sign(ds)*p.hopf.tau; 
p.branch=[p.branch brout]; p.fuha.savefu(p);     % put on branch and save 
fprintf(['\n BP saved to ' p.file.dir '/bpt' mat2str(p.file.bcount,3) '\n']); 
%p.sol.ptype=1; p.fuha.savefu(p);  % save again as BP on  Hopf branch
hoplot(p,p.plot.pfig,p.plot.pcmp); figure(p.plot.brfig); hold on; 
plot(getlam(p),real(brplot),'o'); drawnow; 
p=q; 
p.branch=[p.branch brout];
p.file.bcount=p.file.bcount+1; p.file.count=p.file.count+1; 
end 